Redmine - Feature #5501

Git: Mercurial: Adding visual merge/branch history to repository view
2010-05-11 12:05 - Ralph Broenink

Status: Closed Start date: 2010-05-11
Priority: Normal Due date:

Assignee: Toshi MARUYAMA % Done: 100%
Category: SCM Estimated time: 0.00 hour
Target version: 1.3.0

Resolution: Fixed

Description

| really like the merge/branch lines in 'gitk' (or 'git log --graph’) or the network view at http:/github.com/edavis10/redmine/network. |
couldn't find any plugin or feature request to perform this task, so | would like to suggest as a feature.

Related issues:

Related to Redmine - Feature #5386: Branch/Tags in Changeset Description New 2010-04-27
Related to Redmine - Defect #7984: Confusing revisions links on repository root New 2011-03-24
Related to Redmine - Feature #7246: Handle "named branch" for mercurial Closed 2011-01-07
Related to Redmine - Defect #5357: Git: SCM revisions ordered by date/time (s... New 2010-04-20
Related to Redmine - Defect #3724: Mercurial repositories display revision ID... Closed 2009-08-10
Related to Redmine - Defect #9824: Visual merge/branch history words are cut off Closed

Related to Redmine - Defect #10172: There is no lines on revision graph betwe... Closed

Has duplicate Redmine - Feature #3909: Mercurial: show repository graphic his... Closed 2009-09-23

Associated revisions

Revision 7636 - 2011-10-21 10:19 - Toshi MARUYAMA

css: set margin Opx at top and bottom of changeset ul and ol (#5501)

Revision 7637 - 2011-10-21 13:17 - Toshi MARUYAMA

scm: view: truncate author with length 30 (#5501)

Revision 7638 - 2011-10-21 13:17 - Toshi MARUYAMA

css: set nowrap of changeset author and committed_on (#5501)

Revision 7639 - 2011-10-21 15:08 - Toshi MARUYAMA

scm: view: add #to_s to changeset.author (#5501)

On Ruby 1.8.86, following error raises.

undefined method “mb_chars' for #<ActiveRecord::Associations::BelongsToAssociation:0x7f86950f3e58>
Revision 7653 - 2011-10-25 16:57 - Toshi MARUYAMA

scm: git: use to_s for branches at model (#5501)

"scm.branches" will extend to have the revision for the branch.
no "to_s" will have a problem.

Revision 7654 - 2011-10-25 16:58 - Toshi MARUYAMA

scm: git: return saved revision at model "save_revision" (#5501)

Revision 7662 - 2011-10-28 03:44 - Toshi MARUYAMA

scm: mercurial: update test repository (#5501)

This test repository has one merged revision.

Revision 7663 - 2011-10-28 04:46 - Toshi MARUYAMA
scm: mercurial: add parents to xml log template (#5501)

Revision 7665 - 2011-10-28 06:55 - Toshi MARUYAMA

scm: lib: add parents attribute to Revision class of abstract adapter (#5501)

Revision 7666 - 2011-10-28 06:56 - Toshi MARUYAMA

scm: mercurial: lib: add parents to Revision class (#5501)

Revision 7667 - 2011-10-28 06:57 - Toshi MARUYAMA

scm: mercurial: test: add test of parents to unit lib test (#5501)
Revision 7668 - 2011-10-28 06:58 - Toshi MARUYAMA
scm: git: lib: add parents to Revision class (#5501)
Contributed by Jan Topinski.

Revision 7669 - 2011-10-28 06:59 - Toshi MARUYAMA
scm: git: test: add test of parents to unit lib test (#5501)

Revision 7670 - 2011-10-28 07:17 - Toshi MARUYAMA
scm: lib: add Branch class to abstract adapter (#5501)

Revision 7671 - 2011-10-28 07:17 - Toshi MARUYAMA
scm: git: lib: return array of Branch class instead of array of strings at branches method (#5501)
Contributed by Jan Topinski.

Revision 7672 - 2011-10-28 07:18 - Toshi MARUYAMA

scm: git: test: lib: update branches test for Branch class (#5501)

Revision 7673 - 2011-10-28 07:19 - Toshi MARUYAMA

scm: mercurial: lib: return array of Branch class instead of array of strings at branches method (#5501)

Revision 7674 - 2011-10-28 07:19 - Toshi MARUYAMA

scm: mercurial: test: lib: update branches test for Branch class (#5501)
Revision 7710 - 2011-11-03 09:01 - Toshi MARUYAMA

scm: db: model: add parent/child relation for changesets (#5501)
Contributed by Jan Topiriski.

Revision 7711 - 2011-11-03 09:02 - Toshi MARUYAMA

scm: git: model: save parent/child relation for changesets (#5501)
Contributed by Jan Topinski.

Revision 7712 - 2011-11-03 09:02 - Toshi MARUYAMA
scm: git: test: model: add test of parents (#5501)

Revision 7713 - 2011-11-03 09:03 - Toshi MARUYAMA

scm: mercurial: model: save parent/child relation for changesets (#5501)

Revision 7714 - 2011-11-03 09:03 - Toshi MARUYAMA

scm: mercurial: test: model: add test of parents (#5501)

Revision 7715 - 2011-11-03 09:11 - Toshi MARUYAMA

scm: controller: include parents in changesets (#5501)

Contributed by Jan Topinski.
Revision 7716 - 2011-11-03 09:12 - Toshi MARUYAMA

scm: model: add method to switch revision graph support or not and set default false (#5501)

Revision 7717 - 2011-11-03 09:12 - Toshi MARUYAMA

scm: model: git: set revision graph support true (#5501)

Revision 7718 - 2011-11-03 09:12 - Toshi MARUYAMA

scm: model: mercurial: set revision graph support true (#5501)

Revision 7719 - 2011-11-03 10:58 - Toshi MARUYAMA

scm: mercurial: test: model: fix failing test_parents on PostgreSQL (#5501)

Revision 7720 - 2011-11-03 10:58 - Toshi MARUYAMA
scm: git: test: model: fix failing test_parents on PostgreSQL (#5501)

Revision 7721 - 2011-11-03 12:34 - Toshi MARUYAMA
scm: view: add parents and children on the revision page (#5501)
Contributed by Jan Topinski.

Revision 7722 - 2011-11-03 12:34 - Toshi MARUYAMA

scm: add Japanese translation of parent and child revision (#5501)

Revision 7723 - 2011-11-03 12:35 - Toshi MARUYAMA

scm: update translations of parent and child revision (#5501)

Revision 7724 - 2011-11-03 12:35 - Toshi MARUYAMA
add raphael.js (#5501)

Revision 7725 - 2011-11-03 12:36 - Toshi MARUYAMA

scm: git: mercurial: add a new feature of revision graph (#5501)

Contributed by Jan Topiriski.

Revision 7727 - 2011-11-04 02:33 - Toshi MARUYAMA

scm: view: remove redundant br tag from the revision page (#5501)

Revision 8022 - 2011-12-02 00:41 - Toshi MARUYAMA

scm: git: mercurial: not show revision graph in sub directory (#5501)

History

#1 - 2011-03-23 11:20 - Toshi MARUYAMA
- Category set to SCM

#2 - 2011-09-05 13:29 - Jan Topinski
- File branch-graph-redmine.png added

| made working patch. Please tel me if you like it or not. | don't know if you like it to be added to redmine or shall | made a plugin?

#3 - 2011-09-05 13:30 - Jan Topinski
- File branch-graph-redmine.png added

| made working patch. Please tel me if you like it or not. | don't know if you like it to be added to redmine or shall | made a plugin? Code is at

https://github.com/simcha/redmine.

#4 - 2011-09-05 14:25 - Toshi MARUYAMA
- File bitbucket-thg-shellext.png added
Great work!!
| prefer gitk, TortoiseHg, hgweb, bitbucket styles rather than github style.
e hitp://hg.openttdcoop.org/chiliproject/graph

¢ https://bitbucket.org/redmine/chiliproject/changesets
e https://bitbucket.org/tortoisehg/shellext/changesets

Author Revision Message Date
| E‘_! Steve Borho 5e95a6c86eb3 Added tag 2.1.3 for changeset 99643eaf311b stable 8 days ago
Adrian Buehimann ff667fal7d23 Merge with stable 13 days ago
\ Adrian Buehimann 99643eaf311b wix: extract new thgshellx86dIl.wxi stable 13 days ago
[ Adrian Buehlmann 8785917d8071 wix: extract COM server registration inte new wxi file stable 13 days ago
L] Adrian Buehlmann 202223e009a8 wix: use Class element for overlay handler COM server registrations stable 13 days ago
14 Adrian Buehlmann 8218fal92e37 wix: use Class element for drop handler COM server registration stable 13 days ago
14 Adrian Buehlmann 24bd9e0d1558 wix: use Class element for cmenu COM server registration stable 13 days ago
Adrian Buehlmann dd12afadfd67 Merge with stable 21 days ago
\ Adrian Buehlmann 31bfaed5a77f add missing 2.1.2 tag from thg repo stable 22 days ago
Adrian Bughlmann 9255d4655049 Merge with stable 23 days ago
\ Adrian Buehlmann ch8le3acced3 add shellext version as private property stable 24 days ago
i Adrian Buehlmann 374954695140 add shellext version as private property 24 days ago
b M- Toshi MARUYAMA 89d79cB8e099 InitStatus: Unicode porting 2011-07-26
’ 4 Toshi MARUYAMA 7cB63bf5ef78 Thgstatus: Unicede porting excluding CallNamedPipeA 2011-07-26
i & Toshi MARUYAMA af2792780b4c Tortoiselltils: delete unused GetTortoiselconA 28 days ago
p & Toshi MARUYAMA di73elb3dB4a Unicode porting of icon 2011-07-26

#5 - 2011-09-05 14:31 - Etienne Massip

| agree with Toshi ; moreover that would be easier to integrate into existing revision / change list.

#6 - 2011-09-05 15:02 - Toshi MARUYAMA

- Subject changed from Adding visual merge/branch history to repository view to Git: Adding visual merge/branch history to repository view

#7 - 2011-09-05 20:52 - Jan Topinski

Toshi | also like vertical graph. | will try to make one like this for revision/revisions page.

#8 - 2011-09-06 09:12 - Jan Topinski
- File vertical-graph.png added

So, | made one with no to-the-right-align. | did not do it cause | don't like it and it is some more work ;) let me know it you like this version. | know that
line curve is not ideal and | am aware of some other bugs like margin problem, it is still just a prototype.
vertical-graph.png

#9 - 2011-09-06 09:20 - Etienne Massip

Very nice, indeed!

#10 - 2011-09-06 09:51 - Toshi MARUYAMA
- Status changed from New to 7

- Assignee set to Toshi MARUYAMA

#11 - 2011-09-06 15:13 - Toshi MARUYAMA
- File fix_typo_changeset_parents.diff added

There is table name typo 'changesets_parents'.
It seems that 'changeset_parents' is correct.
This patch fixes it.
#12 - 2011-09-10 11:27 - Jan Topinski
Thanks Toshi patch applied.

#13 - 2011-09-13 11:32 - Sylvain Berfini

Hi. It would be nice to make a plugin for this for the redmine branch. Thanks !

#14 - 2011-10-21 11:28 - Toshi MARUYAMA

- Subject changed from Git: Adding visual merge/branch history to repository view to Git: Mercurial: Adding visual merge/branch history to repository

view

#15 - 2011-11-03 12:42 - Toshi MARUYAMA
- Target version set to 1.3.0

- % Done changed from 0 to 100

#16 - 2011-12-01 10:57 - Toshi MARUYAMA
- File the-shellext.png added
Limitations

Before Redmine 1.2 database data

thg-shellext.png

Fetching revisions before Redmine 1.2 does not have parents revisions.

So, there is no lines between revisions.

If you want to draw lines all revisions,
You need to reset repository.

There is a issue for re-syncing repository (#1273).
Git revision order
Redmine between 0.9 and 1.1 has git database inconsistency (#5357).

Redmine 1.3 git order is date order due to historical reasons.
So, git revision graph is sometimes strange.

#17 - 2011-12-01 10:58 - Toshi MARUYAMA
- File deleted (the-shellext.png)

#18 - 2011-12-01 10:59 - Toshi MARUYAMA
- File thg-shellext.png added

#19 - 2011-12-01 12:00 - Toshi MARUYAMA
- Status changed from 7 to Closed

- Resolution set to Fixed

If you have bugs or improvements, please create new issues.
